<?php
class ControllerExtensionPaymentClickuz extends Controller {
    private $error = array();

    public function index() {
        $this->load->language('extension/payment/clickuz');

        $this->load->model('extension/payment/clickuz');

        $this->load->model('localisation/geo_zone');

        $this->load->model('localisation/order_status');

        $this->load->model('setting/setting');

        $this->document->setTitle($this->language->get('heading_title'));

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {

            $this->model_setting_setting->editSetting('payment_clickuz', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/payment/clickuz', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['error_merchant_id'] = isset($this->error['merchant_id']) ? $this->error['merchant_id'] : '';

        $data['error_merchant_user_id'] = isset($this->error['merchant_user_id']) ? $this->error['merchant_user_id'] : '';

        $data['error_service_id'] = isset($this->error['service_id']) ? $this->error['service_id'] : '';

        $data['error_secret_key'] = isset($this->error['secret_key']) ? $this->error['secret_key'] : '';

        $data['action'] = $this->url->link('extension/payment/clickuz', 'user_token=' . $this->session->data['user_token'], true);

        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        $params = array(
            'payment_clickuz_merchant_id' => '',
            'payment_clickuz_merchant_user_id' => '',
            'payment_clickuz_service_id' => '',
            'payment_clickuz_secret_key' => '',
            'payment_clickuz_status' => 1,
            'payment_clickuz_sort_order' => 1,
            'payment_clickuz_method' => 'only_card',
            'payment_clickuz_order_status_id' => 2,
        );

        foreach( $params as $key => $default ) {

            if( isset($this->request->post[$key]) ) {
                $data[$key] = $this->request->post[$key];
            } elseif($this->config->get($key)) {
                $data[$key] = $this->config->get($key);
            } else {
                $data[$key] = $default;
            }

        }

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/clickuz', $data));
    }

    protected function validate() {
        if (!$this->user->hasPermission('modify', 'extension/payment/clickuz')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->request->post['payment_clickuz_merchant_id']) {
            $this->error['merchant_id'] = $this->language->get('error_merchant_id');
        }

        if (!$this->request->post['payment_clickuz_merchant_user_id']) {
            $this->error['merchant_user_id'] = $this->language->get('error_merchant_user_id');
        }

        if (!$this->request->post['payment_clickuz_service_id']) {
            $this->error['service_id'] = $this->language->get('error_service_id');
        }

        if (!$this->request->post['payment_clickuz_secret_key']) {
            $this->error['secret_key'] = $this->language->get('error_secret_key');
        }

        return !$this->error;
    }

    public function install() {
        $this->load->model('extension/payment/clickuz');

        $this->model_extension_payment_clickuz->install();
    }

    public function uninstall() {
        $this->load->model('extension/payment/clickuz');

        $this->model_extension_payment_clickuz->uninstall();
    }
}